Subject: Re: bug#10128: am_foo_OBJECTS is empty when ...

From: Stefano Lattarini <[email-masked]>
Date: Tue, 03 Jan 2012 18:47:29 +0100

> 
> I've now prepared a test case to correctly expose the bug.
>
And now I've pushed it with the attached patch (it is obviously still
declared as an XFAIL).

Regards,
  Stefano
>From 971000c121b9b79b787435f1eaaa76caa37986ee Mon Sep 17 00:00:00 2001
Message-Id: <971000c12[email-masked]>
From: Stefano Lattarini <[email-masked]>
Date: Mon, 2 Jan 2012 20:32:54 +0100
Subject: [PATCH] coverage: expose automake bug#10128

* tests/objext-pr10128.test: New test, still expected to fail.
* tests/Makefile.am (TESTS, XFAIL_TESTS): Add it.
---
 tests/Makefile.am         |    2 +
 tests/objext-pr10128.test |   60 +++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 62 insertions(+), 0 deletions(-)
 create mode 100755 tests/objext-pr10128.test

diff --git a/tests/Makefile.am b/tests/Makefile.am
index 3d20871..ff56442 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -25,6 +25,7 @@ dist-auxfile.test \
 dist-auxfile-2.test \
 gcj6.test \
 java-nobase.test \
+objext-pr10128.test \
 pr8365-remake-timing.test \
 lex-subobj-nodep.test \
 remake-am-pr10111.test \
@@ -614,6 +615,7 @@ notrans.test \
 number.test \
 objc.test \
 objc2.test \
+objext-pr10128.test \
 obsolete.test \
 order.test \
 outdir.test \
diff --git a/tests/objext-pr10128.test b/tests/objext-pr10128.test
new file mode 100755
index 0000000..0692164
--- /dev/null
+++ b/tests/objext-pr10128.test
@@ -0,0 +1,60 @@
+#! /bin/sh
+# Copyright (C) 2012 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Test for automake bug#10128: $(OBJEXT) redefinition causes
+# $(foo_OBJECTS) to be defined as empty.
+
+. ./defs || Exit 1
+
+set -e
+
+echo AC_OUTPUT >> configure.in
+
+cat > Makefile.am <<'END'
+LINK = echo >$@ Linked $@ from
+OBJEXT = fasl
+EXEEXT =
+
+noinst_PROGRAMS = foo zardoz
+foo_SOURCES = foo.lisp
+zardoz_SOURCES = mu1.lisp mu2.lisp
+
+## Un-commenting this is enough to make the test pass.  Weird!
+##.lisp.o:
+
+.lisp.fasl:
+	touch $@
+
+.PHONY: test
+test:
+	test '$(foo_OBJECTS)'    = 'foo.fasl'
+	test '$(zardoz_OBJECTS)' = 'mu1.fasl mu2.fasl'
+END
+
+$ACLOCAL
+$AUTOMAKE
+$AUTOCONF
+
+./configure
+$MAKE test
+touch foo.lisp mu1.lisp mu2.lisp
+$MAKE all
+cat foo
+cat zardoz
+test "`cat foo`"    = "Linked foo from foo.fasl"
+test "`cat zardoz`" = "Linked zardoz from mu1.fasl mu2.fasl"
+
+:
-- 
1.7.7.3